using System;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.IO;
namespace directhex
{
	class MainClass
	{
		public static void Main(string[] args)
		{
            if (args.Length < 3)
            {
                Console.WriteLine("ERROR! Format - \"server.exe configuration.json fileindex.json out.json\"");
            }
            else
            {
                foreach (string arg in args)
                {
                    Console.WriteLine(arg);
                }
                string jsonString = File.ReadAllText(args[1]);
                if (!string.IsNullOrEmpty(jsonString))
                {
                     Console.WriteLine("Parse jsonString.Length: " + jsonString.Length.ToString() + " " + args[1]);
                    ParsefileList(jsonString);
                }

                string jsonString2 = File.ReadAllText(args[0]);
                if (!string.IsNullOrEmpty(jsonString2))
                {
                    Console.WriteLine("Parse jsonString.Length: " + jsonString2.Length.ToString()+" " + args[0]);
                    configuration = ParseConfigs(jsonString2);
                    

                    File.WriteAllText(args[2], JSONNode.FormatJson(configuration.ToString()));
                }

            }			
		}

        public static Dictionary<string, string> fileList = new Dictionary<string, string>();
        public static JSONNode configuration = null;

        public const string DATA_SET_DAT_KEY = "dataset_dat";
        public const string DATA_SET_XML_KEY = "dataset_xml";
        public const string FIRST_PAGE_DAT_KEY = "first_page_dat";
        public const string FIRST_PAGE_XML_KEY = "first_page_xml";
        public const string IMAGE_KEY = "image";

        public const string BUNDLE_ANDROID_URL_KEY = "bundle_android";
        public const string BUNDLE_IOS_URL_KEY = "bundle_ios";

        public static bool compareString(string a, string b)
        {
            string aformat = a.Replace(".", "_").Replace(" ", "_").ToLower();
            string bformat = b.Replace(".", "_").Replace(" ", "_").ToLower();

            bool compare = (aformat == bformat && aformat.Length == bformat.Length);
            if (compare)
            {
                Console.WriteLine("A:" + a + " B:" + b + " A:" + aformat + " B:" + bformat);
            }
            return compare;      
        }

        public static JSONNode ParseConfigs(string jsonString)
        {
            JSONNode json = JSONNode.Parse(jsonString);


            foreach (JSONNode bookJSON in json["books"].AsArray)
            {

                if (bookJSON != null)
                {
                    string ImageName = bookJSON[IMAGE_KEY];
                    string DataSetDatName = bookJSON[DATA_SET_DAT_KEY];
                    string DataSetXMLName = bookJSON[DATA_SET_XML_KEY];
                    string FirstPageXMLName = bookJSON[FIRST_PAGE_XML_KEY];
                    string FirstPageDatName = bookJSON[FIRST_PAGE_DAT_KEY];
                    foreach (var fileListdata in fileList)
                    {
                        string file_url = fileListdata.Value;
                        string file_name = Path.GetFileName(file_url);
                        string md5 = fileListdata.Key;
                        if (compareString( file_name, ImageName) )
                        {
                            bookJSON.Add(IMAGE_KEY + "_md5", new JSONData(md5));
                            bookJSON.Add(IMAGE_KEY + "_file", new JSONData(file_url));
                        }

                        if (compareString(file_name, DataSetDatName) )
                        {
                            bookJSON.Add(DATA_SET_DAT_KEY + "_md5", new JSONData(md5));
                            bookJSON.Add(DATA_SET_DAT_KEY + "_file", new JSONData(file_url));
                        }

                        if (compareString(file_name, DataSetXMLName) )
                        {
                            bookJSON.Add(DATA_SET_XML_KEY + "_md5", new JSONData(md5));
                            bookJSON.Add(DATA_SET_XML_KEY + "_file", new JSONData(file_url));
                        }

                        if (compareString(file_name, FirstPageXMLName) )
                        {
                            bookJSON.Add(FIRST_PAGE_XML_KEY + "_md5", new JSONData(md5));
                            bookJSON.Add(FIRST_PAGE_XML_KEY + "_file", new JSONData(file_url));
                        }

                        if (compareString(file_name,FirstPageDatName) )
                        {
                            bookJSON.Add(FIRST_PAGE_DAT_KEY + "_md5", new JSONData(md5));
                            bookJSON.Add(FIRST_PAGE_DAT_KEY + "_file", new JSONData(file_url));
                        }
                    }                    
                    
                    


                    foreach (JSONNode languageJSON in bookJSON["Languages"].AsArray)
                    {
                        if (languageJSON != null && languageJSON["ARContent"] != null)
                        {
                            foreach (JSONNode animationJSON in languageJSON["ARContent"].AsArray)
                            {
                                string bundle_android = animationJSON[BUNDLE_ANDROID_URL_KEY];
                                string bundle_ios = animationJSON[BUNDLE_IOS_URL_KEY];
                                foreach (var AfileListdata in fileList)
                                {
                                    string Afile_url = AfileListdata.Value;
                                    string Afile_name = Path.GetFileName(Afile_url);
                                    string Amd5 = AfileListdata.Key;
                                    if (compareString(Afile_name,bundle_ios) )
                                    {
                                        animationJSON.Add(BUNDLE_IOS_URL_KEY + "_md5", new JSONData(Amd5));
                                        animationJSON.Add(BUNDLE_IOS_URL_KEY + "_file", new JSONData(Afile_url));

                                    }
                                    if (compareString(Afile_name,bundle_android) )
                                    {
                                        animationJSON.Add(BUNDLE_ANDROID_URL_KEY + "_md5", new JSONData(Amd5));
                                        animationJSON.Add(BUNDLE_ANDROID_URL_KEY + "_file", new JSONData(Afile_url));
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return json;
        }
        static int asd = 0;
        public static void ParsefileList(string jsonString)
        {
            JSONNode json = JSONNode.Parse(jsonString);
            foreach (JSONNode filesdataJSON in json["filesdata"].AsArray)
            {
                if (filesdataJSON != null && filesdataJSON["key"] != null && filesdataJSON["patch"] != null)
                {
                    string key = filesdataJSON["key"];
                    if (fileList.ContainsKey(key))
                    {
                        fileList.Add(key + asd.ToString(), filesdataJSON["patch"]);
                        asd++;
                    }
                    else
                        fileList.Add(key, filesdataJSON["patch"]);
                    // Console.WriteLine("Key:" + filesdataJSON["key"] + " value:" + filesdataJSON["patch"]);

                }
            }
        }
            
    }
}